----------------------------------------------------------------------------------
-- POLYTECHNIQUE MONTREAL
-- ELE3311 - Systemes logiques programmables 
-- 
-- Module Name:    msa_reg_tb 
-- Description: 
--
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.numeric_std.all;

entity msa_reg_tb is
end msa_reg_tb;



architecture testbench of msa_reg_tb is

  component msa_reg
  port (
    rst_i                 : in    std_logic;
    clk_i                 : in    std_logic;
    next_i                : in    std_logic;
    addr_cnt_rst_o        : out   std_logic;
    addr_cnt_inc_o        : out   std_logic
  );
  end component;

  signal clk                      : std_logic := '0';
  signal rst                      : std_logic := '1';

  signal next_sig                 : std_logic := '0';
  signal addr_cnt_rst             : std_logic;
  signal addr_cnt_inc             : std_logic;

  -- Periode d'horloge
  constant clk_period             : time := 10 ns; -- 100 MHz

  -- Verification
  signal clk_en                   : boolean := true;

begin

  -- Instantiation du composant a verifier - Unit Under Test (UUT)
  UUT: msa_reg
  port map (
    rst_i                 => rst,
    clk_i                 => clk,
    next_i                => next_sig,
    addr_cnt_rst_o        => addr_cnt_rst,
    addr_cnt_inc_o        => addr_cnt_inc
  );

  -- Generation de l'horloge et de la remise a zero
  clk    <= not clk after clk_period/2 when clk_en else
            '0';

  rst    <= '1', '0' after clk_period*10;


  -- Stimulus process
  driver: process
  begin
    -- On synchronise les signaux avec le front descendant de l'horloge
    -- afin de respecter les temps de preparation et de maintien (setup/hold times)
    for i in 0 to 20 loop
      wait until falling_edge(clk);
    end loop;

    -- *** A completer DEBUT ***

    -- Test du reset
    --rst <= '1';
    --wait for clk_period*10;
    --rst <= '0';

    -- Enfoncer le bouton
    wait for clk_period*10;
    next_sig <= '1';

    -- Relâcher le bouton
    wait for clk_period*10;
    next_sig <= '0';

    wait for clk_period*10;

    -- *** A completer FIN ***

    for i in 0 to 100 loop
      wait until falling_edge(clk);
    end loop;

    -- Fin de la sequence de test
    -- Desactivation de l'horloge
    clk_en    <= false;
    wait;
   end process;

end testbench;

